<html>
<head>
<title>OgreOverlayElement.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreOverlayElement.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreOverlayElement_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __OverlayElement_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __OverlayElement_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;OgreUTFString.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringInterface_8h.html">OgreStringInterface.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreOverlayElementCommands_8h.html">OgreOverlayElementCommands.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreRectangle_8h.html">OgreRectangle.h</a>&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>Ogre {
<a name="l00050"></a>00050 <span class="preprocessor">#if OGRE_UNICODE_SUPPORT</span>
<a name="l00051"></a><a class="code" href="group__Overlays.html#gaf7f1d73c45c54848737f8d59741822f0">00051</a> <span class="preprocessor"></span>    <span class="keyword">typedef</span> UTFString <a class="code" href="group__Overlays.html#gaf7f1d73c45c54848737f8d59741822f0">DisplayString</a>;
<a name="l00052"></a><a class="code" href="group__Overlays.html#ga7840a0c97898ebe977e3331199ca28f5">00052</a> <span class="preprocessor">#   define OGRE_DEREF_DISPLAYSTRING_ITERATOR(it) it.getCharacter()</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>    <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="group__Overlays.html#gaf7f1d73c45c54848737f8d59741822f0">DisplayString</a>;
<a name="l00055"></a>00055 <span class="preprocessor">#   define OGRE_DEREF_DISPLAYSTRING_ITERATOR(it) *it</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00059"></a><a class="code" href="group__Overlays.html#gaa7655e44eacdfd45427ff35bde855f36">00059</a>     <span class="keyword">enum</span> <a class="code" href="group__Overlays.html#gaa7655e44eacdfd45427ff35bde855f36" title="Enum describing how the position / size of an element is to be recorded.">GuiMetricsMode</a>
<a name="l00060"></a>00060     {
<a name="l00062"></a><a class="code" href="group__Overlays.html#ggaa7655e44eacdfd45427ff35bde855f36ae7050335374e46745e3c956b940ace9d">00062</a>         <a class="code" href="group__Overlays.html#ggaa7655e44eacdfd45427ff35bde855f36ae7050335374e46745e3c956b940ace9d" title="&#39;left&#39;, &#39;top&#39;, &#39;height&#39; and &#39;width&#39; are parametrics from 0.0 to 1.0">GMM_RELATIVE</a>,
<a name="l00064"></a><a class="code" href="group__Overlays.html#ggaa7655e44eacdfd45427ff35bde855f36a1995cd35704cb8894f502f135b46309d">00064</a>         <a class="code" href="group__Overlays.html#ggaa7655e44eacdfd45427ff35bde855f36a1995cd35704cb8894f502f135b46309d" title="Positions &amp; sizes are in absolute pixels.">GMM_PIXELS</a>,
<a name="l00066"></a><a class="code" href="group__Overlays.html#ggaa7655e44eacdfd45427ff35bde855f36a2664ae89e7bd4079392f7feff26b3597">00066</a>         <a class="code" href="group__Overlays.html#ggaa7655e44eacdfd45427ff35bde855f36a2664ae89e7bd4079392f7feff26b3597" title="Positions &amp; sizes are in virtual pixels.">GMM_RELATIVE_ASPECT_ADJUSTED</a>
<a name="l00067"></a>00067     };
<a name="l00068"></a>00068 
<a name="l00072"></a><a class="code" href="group__Overlays.html#ga3396780cdb2d731aa5e4389148bdc5f3">00072</a>     <span class="keyword">enum</span> <a class="code" href="group__Overlays.html#ga3396780cdb2d731aa5e4389148bdc5f3" title="Enum describing where &#39;0&#39; is in relation to the parent in the horizontal dimension.">GuiHorizontalAlignment</a>
<a name="l00073"></a>00073     {
<a name="l00074"></a><a class="code" href="group__Overlays.html#gga3396780cdb2d731aa5e4389148bdc5f3a69adf8fd8fa9b00e1c4eba735d0a17cb">00074</a>         <a class="code" href="group__Overlays.html#gga3396780cdb2d731aa5e4389148bdc5f3a69adf8fd8fa9b00e1c4eba735d0a17cb">GHA_LEFT</a>,
<a name="l00075"></a><a class="code" href="group__Overlays.html#gga3396780cdb2d731aa5e4389148bdc5f3a64a73804088bb89e7243a14874a457cd">00075</a>         <a class="code" href="group__Overlays.html#gga3396780cdb2d731aa5e4389148bdc5f3a64a73804088bb89e7243a14874a457cd">GHA_CENTER</a>,
<a name="l00076"></a><a class="code" href="group__Overlays.html#gga3396780cdb2d731aa5e4389148bdc5f3a270f18cf07dbe4e75e1b790d02924205">00076</a>         <a class="code" href="group__Overlays.html#gga3396780cdb2d731aa5e4389148bdc5f3a270f18cf07dbe4e75e1b790d02924205">GHA_RIGHT</a>
<a name="l00077"></a>00077     };
<a name="l00081"></a><a class="code" href="group__Overlays.html#gab0815ab90a2d9635695ec7e20e6c372e">00081</a>     <span class="keyword">enum</span> <a class="code" href="group__Overlays.html#gab0815ab90a2d9635695ec7e20e6c372e" title="Enum describing where &#39;0&#39; is in relation to the parent in the vertical dimension.">GuiVerticalAlignment</a>
<a name="l00082"></a>00082     {
<a name="l00083"></a><a class="code" href="group__Overlays.html#ggab0815ab90a2d9635695ec7e20e6c372eabd89b9daa45f558ebf40181220421c2b">00083</a>         <a class="code" href="group__Overlays.html#ggab0815ab90a2d9635695ec7e20e6c372eabd89b9daa45f558ebf40181220421c2b">GVA_TOP</a>,
<a name="l00084"></a><a class="code" href="group__Overlays.html#ggab0815ab90a2d9635695ec7e20e6c372ea730c870b4637187418842a7545a8d40b">00084</a>         <a class="code" href="group__Overlays.html#ggab0815ab90a2d9635695ec7e20e6c372ea730c870b4637187418842a7545a8d40b">GVA_CENTER</a>,
<a name="l00085"></a><a class="code" href="group__Overlays.html#ggab0815ab90a2d9635695ec7e20e6c372eae1858486046629fda36e43b0bfece87a">00085</a>         <a class="code" href="group__Overlays.html#ggab0815ab90a2d9635695ec7e20e6c372eae1858486046629fda36e43b0bfece87a">GVA_BOTTOM</a>
<a name="l00086"></a>00086     };
<a name="l00087"></a>00087 
<a name="l00109"></a><a class="code" href="classOgre_1_1OverlayElement.html">00109</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.">StringInterface</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">OverlayAlloc</a>
<a name="l00110"></a>00110     {
<a name="l00111"></a>00111     <span class="keyword">public</span>:
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     <span class="keyword">protected</span>:
<a name="l00114"></a>00114         <span class="comment">// Command object for setting / getting parameters</span>
<a name="l00115"></a><a class="code" href="classOgre_1_1OverlayElement.html#aad27d116d1e7fb26458697a52751f4f8">00115</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdLeft.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdLeft</a> <a class="code" href="classOgre_1_1OverlayElement.html#aad27d116d1e7fb26458697a52751f4f8">msLeftCmd</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1OverlayElement.html#a0da8176115f510237a9a20c07083a63e">00116</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdTop.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdTop</a> <a class="code" href="classOgre_1_1OverlayElement.html#a0da8176115f510237a9a20c07083a63e">msTopCmd</a>;
<a name="l00117"></a><a class="code" href="classOgre_1_1OverlayElement.html#a925b145f6e18d942032cb3d7d8796353">00117</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdWidth.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdWidth</a> <a class="code" href="classOgre_1_1OverlayElement.html#a925b145f6e18d942032cb3d7d8796353">msWidthCmd</a>;
<a name="l00118"></a><a class="code" href="classOgre_1_1OverlayElement.html#af3f10d962eccc87778362df373a1db1c">00118</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdHeight.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdHeight</a> <a class="code" href="classOgre_1_1OverlayElement.html#af3f10d962eccc87778362df373a1db1c">msHeightCmd</a>;
<a name="l00119"></a><a class="code" href="classOgre_1_1OverlayElement.html#a6c8b779590948e7f0d03a4fb9cd58d3f">00119</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdMaterial.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdMaterial</a> <a class="code" href="classOgre_1_1OverlayElement.html#a6c8b779590948e7f0d03a4fb9cd58d3f">msMaterialCmd</a>;
<a name="l00120"></a><a class="code" href="classOgre_1_1OverlayElement.html#a2961a031e5a99abd1f3b2cb375392699">00120</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdCaption.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdCaption</a> <a class="code" href="classOgre_1_1OverlayElement.html#a2961a031e5a99abd1f3b2cb375392699">msCaptionCmd</a>;
<a name="l00121"></a><a class="code" href="classOgre_1_1OverlayElement.html#a0261751d3f72d9fbc8f412328d20aa5c">00121</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdMetricsMode.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdMetricsMode</a> <a class="code" href="classOgre_1_1OverlayElement.html#a0261751d3f72d9fbc8f412328d20aa5c">msMetricsModeCmd</a>;
<a name="l00122"></a><a class="code" href="classOgre_1_1OverlayElement.html#a7dc75d25f6b254a6dcdd5f1286b2549c">00122</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdHorizontalAlign.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdHorizontalAlign</a> <a class="code" href="classOgre_1_1OverlayElement.html#a7dc75d25f6b254a6dcdd5f1286b2549c">msHorizontalAlignCmd</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1OverlayElement.html#a1a0ec943fea94c1b8f7642c62a6cb016">00123</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdVerticalAlign.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdVerticalAlign</a> <a class="code" href="classOgre_1_1OverlayElement.html#a1a0ec943fea94c1b8f7642c62a6cb016">msVerticalAlignCmd</a>;
<a name="l00124"></a><a class="code" href="classOgre_1_1OverlayElement.html#a3424b9ef1d5079007c412b2dc01aad30">00124</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1OverlayElementCommands_1_1CmdVisible.html" title="Command object for OverlayElement - see ParamCommand.">OverlayElementCommands::CmdVisible</a> <a class="code" href="classOgre_1_1OverlayElement.html#a3424b9ef1d5079007c412b2dc01aad30">msVisibleCmd</a>;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classOgre_1_1OverlayElement.html#ae4b117844cab0a348d7e3dc468accef5">00127</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1OverlayElement.html#ae4b117844cab0a348d7e3dc468accef5">mName</a>;
<a name="l00128"></a><a class="code" href="classOgre_1_1OverlayElement.html#adcbd39c953ec83906ca7f6a2aab2d73a">00128</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OverlayElement.html#adcbd39c953ec83906ca7f6a2aab2d73a">mVisible</a>;
<a name="l00129"></a><a class="code" href="classOgre_1_1OverlayElement.html#a78342f0f8361eec292c0a2fffeb4802c">00129</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OverlayElement.html#a78342f0f8361eec292c0a2fffeb4802c">mCloneable</a>;
<a name="l00130"></a><a class="code" href="classOgre_1_1OverlayElement.html#ac7a3836dc035fb43ff9bb751d9f362a1">00130</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#ac7a3836dc035fb43ff9bb751d9f362a1">mLeft</a>;
<a name="l00131"></a><a class="code" href="classOgre_1_1OverlayElement.html#ac8a54669239d58f5002ecd9c85c43d9a">00131</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#ac8a54669239d58f5002ecd9c85c43d9a">mTop</a>;
<a name="l00132"></a><a class="code" href="classOgre_1_1OverlayElement.html#a82b778507f250b336a17638d09e2185b">00132</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#a82b778507f250b336a17638d09e2185b">mWidth</a>;
<a name="l00133"></a><a class="code" href="classOgre_1_1OverlayElement.html#ad857b4fd17e0406ee11c35f691ba0ec0">00133</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#ad857b4fd17e0406ee11c35f691ba0ec0">mHeight</a>;
<a name="l00134"></a><a class="code" href="classOgre_1_1OverlayElement.html#a434709c526e28fc7aaae30f9b62c7ab3">00134</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1OverlayElement.html#a434709c526e28fc7aaae30f9b62c7ab3">mMaterialName</a>;
<a name="l00135"></a><a class="code" href="classOgre_1_1OverlayElement.html#ad1fc124a9614f9ad1903b4f0a418c7e5">00135</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1OverlayElement.html#ad1fc124a9614f9ad1903b4f0a418c7e5">mMaterial</a>;
<a name="l00136"></a><a class="code" href="classOgre_1_1OverlayElement.html#a8ea6ffe210e2eb91a12ba3789e064aad">00136</a>         <a class="code" href="group__Overlays.html#gaf7f1d73c45c54848737f8d59741822f0">DisplayString</a> <a class="code" href="classOgre_1_1OverlayElement.html#a8ea6ffe210e2eb91a12ba3789e064aad">mCaption</a>;
<a name="l00137"></a><a class="code" href="classOgre_1_1OverlayElement.html#a0990d36153aa96720ebe80413ede02c4">00137</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1OverlayElement.html#a0990d36153aa96720ebe80413ede02c4">mColour</a>;
<a name="l00138"></a><a class="code" href="classOgre_1_1OverlayElement.html#a69e4bbdac0a318ac3058567ad3a2cfce">00138</a>         <a class="code" href="structOgre_1_1Rectangle.html">Rectangle</a> <a class="code" href="classOgre_1_1OverlayElement.html#a69e4bbdac0a318ac3058567ad3a2cfce">mClippingRegion</a>;
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="classOgre_1_1OverlayElement.html#a5a5c8d65d2c18b8c48e9dcd86b7f33e3">00140</a>         <a class="code" href="group__Overlays.html#gaa7655e44eacdfd45427ff35bde855f36" title="Enum describing how the position / size of an element is to be recorded.">GuiMetricsMode</a> <a class="code" href="classOgre_1_1OverlayElement.html#a5a5c8d65d2c18b8c48e9dcd86b7f33e3">mMetricsMode</a>;
<a name="l00141"></a><a class="code" href="classOgre_1_1OverlayElement.html#af1a87b28872f5b0a9b7c97c82681c5f4">00141</a>         <a class="code" href="group__Overlays.html#ga3396780cdb2d731aa5e4389148bdc5f3" title="Enum describing where &#39;0&#39; is in relation to the parent in the horizontal dimension.">GuiHorizontalAlignment</a> <a class="code" href="classOgre_1_1OverlayElement.html#af1a87b28872f5b0a9b7c97c82681c5f4">mHorzAlign</a>;
<a name="l00142"></a><a class="code" href="classOgre_1_1OverlayElement.html#a10881a2d97133ea47f010e07eb92db55">00142</a>         <a class="code" href="group__Overlays.html#gab0815ab90a2d9635695ec7e20e6c372e" title="Enum describing where &#39;0&#39; is in relation to the parent in the vertical dimension.">GuiVerticalAlignment</a> <a class="code" href="classOgre_1_1OverlayElement.html#a10881a2d97133ea47f010e07eb92db55">mVertAlign</a>;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144         <span class="comment">// metric-mode positions, used in GMM_PIXELS &amp; GMM_RELATIVE_ASPECT_ADJUSTED mode.</span>
<a name="l00145"></a><a class="code" href="classOgre_1_1OverlayElement.html#a51cb9c486a2d8828a4f9f7d1408a03fc">00145</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#a51cb9c486a2d8828a4f9f7d1408a03fc">mPixelTop</a>;
<a name="l00146"></a><a class="code" href="classOgre_1_1OverlayElement.html#ac51bcf69467cad9c9740fe30b57a4918">00146</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#ac51bcf69467cad9c9740fe30b57a4918">mPixelLeft</a>;
<a name="l00147"></a><a class="code" href="classOgre_1_1OverlayElement.html#a5c61da96a4908e26ea47ce127f80670a">00147</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#a5c61da96a4908e26ea47ce127f80670a">mPixelWidth</a>;
<a name="l00148"></a><a class="code" href="classOgre_1_1OverlayElement.html#ab2eaf1a67eb6235617aeffaa79745b65">00148</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#ab2eaf1a67eb6235617aeffaa79745b65">mPixelHeight</a>;
<a name="l00149"></a><a class="code" href="classOgre_1_1OverlayElement.html#ac80195b0d7e5a9beb9a8c70ec720e8e4">00149</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#ac80195b0d7e5a9beb9a8c70ec720e8e4">mPixelScaleX</a>;
<a name="l00150"></a><a class="code" href="classOgre_1_1OverlayElement.html#a28a252daf4c3bfda6483e22d87ca5f0a">00150</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#a28a252daf4c3bfda6483e22d87ca5f0a">mPixelScaleY</a>;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152         <span class="comment">// Parent pointer</span>
<a name="l00153"></a><a class="code" href="classOgre_1_1OverlayElement.html#a4296f5ad50d9d4e300cb9fb669dc8cb7">00153</a>         <a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* <a class="code" href="classOgre_1_1OverlayElement.html#a4296f5ad50d9d4e300cb9fb669dc8cb7">mParent</a>;
<a name="l00154"></a>00154         <span class="comment">// Overlay attached to</span>
<a name="l00155"></a><a class="code" href="classOgre_1_1OverlayElement.html#af3be0d6cf0526f1355d900ace77c65dd">00155</a>         <a class="code" href="classOgre_1_1Overlay.html" title="Represents a layer which is rendered on top of the &#39;normal&#39; scene contents.">Overlay</a>* <a class="code" href="classOgre_1_1OverlayElement.html#af3be0d6cf0526f1355d900ace77c65dd">mOverlay</a>;
<a name="l00156"></a>00156 
<a name="l00157"></a>00157         <span class="comment">// Derived positions from parent</span>
<a name="l00158"></a><a class="code" href="classOgre_1_1OverlayElement.html#a4065ea999ba9b8e3fe470bf968cf3301">00158</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#a4065ea999ba9b8e3fe470bf968cf3301">mDerivedLeft</a>;
<a name="l00159"></a><a class="code" href="classOgre_1_1OverlayElement.html#a0dd48785ff6f60c41808bb6b10ff439f">00159</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#a0dd48785ff6f60c41808bb6b10ff439f">mDerivedTop</a>;
<a name="l00160"></a><a class="code" href="classOgre_1_1OverlayElement.html#a6d8c9783596c5e8b24e9f75b37466ba1">00160</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OverlayElement.html#a6d8c9783596c5e8b24e9f75b37466ba1">mDerivedOutOfDate</a>;
<a name="l00161"></a>00161 
<a name="l00163"></a><a class="code" href="classOgre_1_1OverlayElement.html#a7173d970f0e2e2f72e32556539dec758">00163</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OverlayElement.html#a7173d970f0e2e2f72e32556539dec758" title="Flag indicating if the vertex positions need recalculating.">mGeomPositionsOutOfDate</a>;
<a name="l00165"></a><a class="code" href="classOgre_1_1OverlayElement.html#ac9f26786254011564b53a020fd39b61a">00165</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OverlayElement.html#ac9f26786254011564b53a020fd39b61a" title="Flag indicating if the vertex uvs need recalculating.">mGeomUVsOutOfDate</a>;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167         <span class="comment">// Zorder for when sending to render queue</span>
<a name="l00168"></a>00168         <span class="comment">// Derived from parent</span>
<a name="l00169"></a><a class="code" href="classOgre_1_1OverlayElement.html#a760a0b20fde4a1503943c8c79e364c87">00169</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1OverlayElement.html#a760a0b20fde4a1503943c8c79e364c87">mZOrder</a>;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171         <span class="comment">// world transforms</span>
<a name="l00172"></a><a class="code" href="classOgre_1_1OverlayElement.html#a74cf6de2418d49a2b47c78faf03985c3">00172</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1OverlayElement.html#a74cf6de2418d49a2b47c78faf03985c3">mXForm</a>;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174         <span class="comment">// is element enabled</span>
<a name="l00175"></a><a class="code" href="classOgre_1_1OverlayElement.html#a10f43416808154d0ce315c624a9e9ab5">00175</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OverlayElement.html#a10f43416808154d0ce315c624a9e9ab5">mEnabled</a>;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177         <span class="comment">// is element initialised</span>
<a name="l00178"></a><a class="code" href="classOgre_1_1OverlayElement.html#a993d69c92b6b0d9eb018bb52ff3c5773">00178</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1OverlayElement.html#a993d69c92b6b0d9eb018bb52ff3c5773">mInitialised</a>;
<a name="l00179"></a>00179 
<a name="l00180"></a>00180         <span class="comment">// Used to see if this element is created from a Template</span>
<a name="l00181"></a><a class="code" href="classOgre_1_1OverlayElement.html#a6dd23c458b57f0584df1109788981e2b">00181</a>         <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* <a class="code" href="classOgre_1_1OverlayElement.html#a6dd23c458b57f0584df1109788981e2b">mSourceTemplate</a> ;
<a name="l00182"></a>00182 
<a name="l00187"></a>00187         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updatePositionGeometry(<span class="keywordtype">void</span>) = 0;
<a name="l00192"></a>00192         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateTextureGeometry(<span class="keywordtype">void</span>) = 0;
<a name="l00193"></a>00193 
<a name="l00202"></a>00202         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addBaseParameters(<span class="keywordtype">void</span>);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204     <span class="keyword">public</span>:
<a name="l00206"></a>00206         <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00207"></a>00207         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>();
<a name="l00208"></a>00208 
<a name="l00210"></a>00210         <span class="keyword">virtual</span> <span class="keywordtype">void</span> initialise(<span class="keywordtype">void</span>) = 0;
<a name="l00211"></a>00211 
<a name="l00213"></a>00213         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00217"></a>00217         <span class="keyword">virtual</span> <span class="keywordtype">void</span> show(<span class="keywordtype">void</span>);
<a name="l00218"></a>00218 
<a name="l00220"></a>00220         <span class="keyword">virtual</span> <span class="keywordtype">void</span> hide(<span class="keywordtype">void</span>);
<a name="l00221"></a>00221 
<a name="l00223"></a>00223         <span class="keywordtype">bool</span> isVisible(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00224"></a>00224 
<a name="l00225"></a>00225         <span class="keywordtype">bool</span> isEnabled() <span class="keyword">const</span>;
<a name="l00226"></a>00226         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setEnabled(<span class="keywordtype">bool</span> b);
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00230"></a>00230         <span class="keywordtype">void</span> setDimensions(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height);
<a name="l00231"></a>00231 
<a name="l00234"></a>00234         <span class="keywordtype">void</span> setPosition(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top);
<a name="l00235"></a>00235 
<a name="l00237"></a>00237         <span class="keywordtype">void</span> setWidth(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width);
<a name="l00239"></a>00239         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getWidth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00240"></a>00240 
<a name="l00242"></a>00242         <span class="keywordtype">void</span> setHeight(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height);
<a name="l00244"></a>00244         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getHeight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00245"></a>00245 
<a name="l00247"></a>00247         <span class="keywordtype">void</span> setLeft(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left);
<a name="l00249"></a>00249         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getLeft(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00250"></a>00250 
<a name="l00252"></a>00252         <span class="keywordtype">void</span> setTop(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Top);
<a name="l00254"></a>00254         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTop(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00255"></a>00255 
<a name="l00257"></a><a class="code" href="classOgre_1_1OverlayElement.html#a6c950a9e2d6e30d6c1defc2de6afd471">00257</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#a6c950a9e2d6e30d6c1defc2de6afd471" title="Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)...">_getLeft</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLeft; }
<a name="l00259"></a><a class="code" href="classOgre_1_1OverlayElement.html#a25a0094a5035c691af46b4498367eb83">00259</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#a25a0094a5035c691af46b4498367eb83" title="Gets the top of this element in relation to the screen (where 0 = far left, 1.0 = far right)...">_getTop</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTop; }
<a name="l00261"></a><a class="code" href="classOgre_1_1OverlayElement.html#aeff6efbeb988718eb6ca90386beaeaf9">00261</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#aeff6efbeb988718eb6ca90386beaeaf9" title="Gets the width of this element in relation to the screen (where 1.0 = screen width)">_getWidth</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mWidth; }
<a name="l00263"></a><a class="code" href="classOgre_1_1OverlayElement.html#a60a6f4e492f466c8b14085fbf75e88a6">00263</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1OverlayElement.html#a60a6f4e492f466c8b14085fbf75e88a6" title="Gets the height of this element in relation to the screen (where 1.0 = screen height)">_getHeight</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHeight; }
<a name="l00265"></a>00265         <span class="keywordtype">void</span> _setLeft(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left);
<a name="l00267"></a>00267         <span class="keywordtype">void</span> _setTop(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top);
<a name="l00269"></a>00269         <span class="keywordtype">void</span> _setWidth(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width);
<a name="l00271"></a>00271         <span class="keywordtype">void</span> _setHeight(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height);
<a name="l00273"></a>00273         <span class="keywordtype">void</span> _setPosition(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top);
<a name="l00275"></a>00275         <span class="keywordtype">void</span> _setDimensions(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height);
<a name="l00276"></a>00276 
<a name="l00278"></a>00278         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMaterialName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00279"></a>00279 
<a name="l00290"></a>00290         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMaterialName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; matName);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293         <span class="comment">// --- Renderable Overrides ---</span>
<a name="l00295"></a>00295 <span class="comment"></span>        <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00296"></a>00296 
<a name="l00297"></a>00297         <span class="comment">// NB getRenderOperation not implemented, still abstract here</span>
<a name="l00298"></a>00298 
<a name="l00300"></a>00300         <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00301"></a>00301 
<a name="l00303"></a>00303         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _positionsOutOfDate(<span class="keywordtype">void</span>);
<a name="l00304"></a>00304 
<a name="l00306"></a>00306         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _update(<span class="keywordtype">void</span>);
<a name="l00307"></a>00307 
<a name="l00309"></a>00309         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateFromParent(<span class="keywordtype">void</span>);
<a name="l00310"></a>00310 
<a name="l00312"></a>00312         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParent(<a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* parent, <a class="code" href="classOgre_1_1Overlay.html" title="Represents a layer which is rendered on top of the &#39;normal&#39; scene contents.">Overlay</a>* overlay);
<a name="l00313"></a>00313 
<a name="l00315"></a>00315         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> _getDerivedLeft(<span class="keywordtype">void</span>);
<a name="l00316"></a>00316 
<a name="l00318"></a>00318         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> _getDerivedTop(<span class="keywordtype">void</span>);
<a name="l00319"></a>00319 
<a name="l00321"></a>00321         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> _getRelativeWidth(<span class="keywordtype">void</span>);
<a name="l00323"></a>00323         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> _getRelativeHeight(<span class="keywordtype">void</span>);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00327"></a>00327         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _getClippingRegion(<a class="code" href="structOgre_1_1Rectangle.html">Rectangle</a> &amp;clippingRegion);
<a name="l00328"></a>00328 
<a name="l00341"></a>00341         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> _notifyZOrder(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> newZOrder);
<a name="l00342"></a>00342 
<a name="l00346"></a>00346         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyWorldTransforms(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; xform);
<a name="l00347"></a>00347 
<a name="l00351"></a>00351         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyViewport();
<a name="l00352"></a>00352 
<a name="l00354"></a>00354         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00355"></a>00355 
<a name="l00357"></a>00357         <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00358"></a>00358             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>);
<a name="l00359"></a>00359 
<a name="l00361"></a>00361         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTypeName(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00362"></a>00362 
<a name="l00369"></a>00369         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCaption(<span class="keyword">const</span> <a class="code" href="group__Overlays.html#gaf7f1d73c45c54848737f8d59741822f0">DisplayString</a>&amp; text);
<a name="l00371"></a>00371         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="group__Overlays.html#gaf7f1d73c45c54848737f8d59741822f0">DisplayString</a>&amp; getCaption(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00378"></a>00378         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setColour(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; col);
<a name="l00379"></a>00379 
<a name="l00381"></a>00381         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getColour(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00382"></a>00382 
<a name="l00393"></a>00393         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMetricsMode(<a class="code" href="group__Overlays.html#gaa7655e44eacdfd45427ff35bde855f36" title="Enum describing how the position / size of an element is to be recorded.">GuiMetricsMode</a> gmm);
<a name="l00395"></a>00395         <span class="keyword">virtual</span> <a class="code" href="group__Overlays.html#gaa7655e44eacdfd45427ff35bde855f36" title="Enum describing how the position / size of an element is to be recorded.">GuiMetricsMode</a> getMetricsMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00411"></a>00411         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setHorizontalAlignment(<a class="code" href="group__Overlays.html#ga3396780cdb2d731aa5e4389148bdc5f3" title="Enum describing where &#39;0&#39; is in relation to the parent in the horizontal dimension.">GuiHorizontalAlignment</a> gha);
<a name="l00413"></a>00413         <span class="keyword">virtual</span> <a class="code" href="group__Overlays.html#ga3396780cdb2d731aa5e4389148bdc5f3" title="Enum describing where &#39;0&#39; is in relation to the parent in the horizontal dimension.">GuiHorizontalAlignment</a> getHorizontalAlignment(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00429"></a>00429         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVerticalAlignment(<a class="code" href="group__Overlays.html#gab0815ab90a2d9635695ec7e20e6c372e" title="Enum describing where &#39;0&#39; is in relation to the parent in the vertical dimension.">GuiVerticalAlignment</a> gva);
<a name="l00431"></a>00431         <span class="keyword">virtual</span> <a class="code" href="group__Overlays.html#gab0815ab90a2d9635695ec7e20e6c372e" title="Enum describing where &#39;0&#39; is in relation to the parent in the vertical dimension.">GuiVerticalAlignment</a> getVerticalAlignment(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00437"></a>00437         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> contains(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y) <span class="keyword">const</span>;
<a name="l00438"></a>00438 
<a name="l00440"></a>00440         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* findElementAt(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y);      <span class="comment">// relative to parent</span>
<a name="l00441"></a>00441 
<a name="l00445"></a><a class="code" href="classOgre_1_1OverlayElement.html#a044f3547a6f365b85914351b2dcb01d5">00445</a>         <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isContainer()<span class="keyword"> const</span>
<a name="l00446"></a>00446 <span class="keyword">        </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00447"></a>00447 
<a name="l00448"></a><a class="code" href="classOgre_1_1OverlayElement.html#ab849874b7c8c7bc23a0332b73e6c7d56">00448</a>         <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isKeyEnabled()<span class="keyword"> const</span>
<a name="l00449"></a>00449 <span class="keyword">        </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00450"></a>00450 
<a name="l00451"></a><a class="code" href="classOgre_1_1OverlayElement.html#aa7760b7652179d76d55308775de5afd9">00451</a>         <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isCloneable()<span class="keyword"> const</span>
<a name="l00452"></a>00452 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mCloneable; }
<a name="l00453"></a>00453 
<a name="l00454"></a><a class="code" href="classOgre_1_1OverlayElement.html#a5677c2c826a60e516aadececb38c86ab">00454</a>         <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCloneable(<span class="keywordtype">bool</span> c)
<a name="l00455"></a>00455         { mCloneable = c; }
<a name="l00456"></a>00456 
<a name="l00460"></a>00460         <a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* getParent() ;
<a name="l00461"></a><a class="code" href="classOgre_1_1OverlayElement.html#a950a51f806779b3ae50adc1cb05fff95">00461</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1OverlayElement.html#a950a51f806779b3ae50adc1cb05fff95">_setParent</a>(<a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* parent) { mParent = parent; }
<a name="l00462"></a>00462 
<a name="l00466"></a><a class="code" href="classOgre_1_1OverlayElement.html#a120aff864144e12388436619f045f590">00466</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getZOrder()<span class="keyword"> const</span>
<a name="l00467"></a>00467 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mZOrder; }
<a name="l00468"></a>00468 
<a name="l00470"></a><a class="code" href="classOgre_1_1OverlayElement.html#a19d352bfdd2208dd99a3715eafc430b5">00470</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam)<span class="keyword"> const </span>
<a name="l00471"></a>00471 <span class="keyword">        </span>{ 
<a name="l00472"></a>00472             (void)cam;
<a name="l00473"></a>00473             <span class="keywordflow">return</span> 10000.0f - (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)getZOrder(); 
<a name="l00474"></a>00474         }
<a name="l00475"></a>00475 
<a name="l00477"></a><a class="code" href="classOgre_1_1OverlayElement.html#a5c74b565888104abe9270726994164a2">00477</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00478"></a>00478 <span class="keyword">        </span>{
<a name="l00479"></a>00479             <span class="comment">// Overlayelements should not be lit by the scene, this will not get called</span>
<a name="l00480"></a>00480             <span class="keyword">static</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a> ll;
<a name="l00481"></a>00481             <span class="keywordflow">return</span> ll;
<a name="l00482"></a>00482         }
<a name="l00483"></a>00483 
<a name="l00484"></a>00484         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyFromTemplate(<a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* templateOverlay);
<a name="l00485"></a>00485         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* clone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName);
<a name="l00486"></a>00486 
<a name="l00487"></a>00487         <span class="comment">// Returns the SourceTemplate for this element</span>
<a name="l00488"></a><a class="code" href="classOgre_1_1OverlayElement.html#a091d48e775c26ea367bdb67f6c966019">00488</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* <a class="code" href="classOgre_1_1OverlayElement.html#a091d48e775c26ea367bdb67f6c966019">getSourceTemplate</a> ()<span class="keyword"> const </span>{
<a name="l00489"></a>00489           <span class="keywordflow">return</span> mSourceTemplate ;
<a name="l00490"></a>00490         }
<a name="l00491"></a>00491     };
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 
<a name="l00497"></a>00497 }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 <span class="preprocessor">#endif</span>
<a name="l00501"></a>00501 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
